<?php

$path = isset($_SERVER["PATH_INFO"]) ? $_SERVER["PATH_INFO"] : "/";

// First, connect to database
try
{
  $db = new PDO('sqlite:'.__DIR__.'/database.db');
}
catch (PDOException $e)
{
  echo 'Connection to database failed: ' . $e->getMessage();
}

// Check for supplied authentication
if(isset($_SERVER['PHP_AUTH_USER']) && isset($_SERVER['PHP_AUTH_PW']))
{
  $user = $_SERVER['PHP_AUTH_USER'];
  $pass = $_SERVER['PHP_AUTH_PW'];

  $password_hash = hash("sha512", $pass);

  $query = "SELECT * FROM users WHERE user = ? AND password = ?";
  $stmt = $db->prepare($query);
  $stmt->execute(array($user, $password_hash));

  $res = $stmt->fetchAll();

  if(count($res) === 0)
  {
    http_response_code(401);
    echo "The specified credentials are invalid!";
    exit(0);
  }
  
  $user = $res[0];
}

header("content-type: application/json");

// Home page
if ($path === "/") {
  echo "{\"msg\": \"Oh my API\"}";
  exit(0);
}

// Get user information
else if($path === "/user")
{
  ?>{"user": "<?=$user["user"]?>", "admin": <?=$user["is_admin"]?"true":"false"?>}<?php
  exit(0);
}

// 404 not found
else {
  http_response_code(404);
  echo "\"404 Not Found\"";
}